#include <stdio.h>
#include <strings.h>

#define DELAY 50
#define NAME_LEN 16
#define SCR_WIDTH 80
#define SCR_HEIGHT 25
#define MAXUSERS 14

/*network related*/
#define ADDR_PROTOCOL AF_INET
#define PROTOCOL PF_INET
#define PORT_NUM 5555
struct portsock{
  int family;
  int port;
  };
struct sock_in addr_in;

#define WHCHANGED 16
#define SPEED 9600
#define CHANGE_NUM ((((SPEED)/8)/4)-WHCHANGED)
#define POS_NUM 9

/*layout symbols*/
#define MAP_TYPE 1
#define STATUS_TYPE 2
#define MESSAGE_TYPE 3
#define TIME_TYPE 4

struct user{
  unsigned char id;
  int 	x, y, room, color;
  char	direction, symbol, type, team;
  char	status;
  char	name[NAME_LEN];
  };

struct game{
  int 	delay, port;
  char 	color, teams, special;
  char 	screen[SCR_WIDTH][SCR_HEIGHT];
  int 	map[M_WIDTH][M_HEIGHT];
  struct rulesets rules;
  char 	whatchanged[WHCHANGED];
  char 	changes[CHANGE_NUM];
  };

struct wire{
  unsigned char id;
  char on, dir;
  }

struct position{
  int x, y;
  };

struct level{
  struct room rooms[256];
  char hint[80][2];
  char story[80][20];
  }

struct rulesets{
  struct physics;
  struct map;
  struct layout;
  }
/* Physics */
#define WRAP		0200
#define WALLS		0100
#define JUMPS		040	/*not yet implemented*/
#define TELEPORTS	020	
#define INVISIBLE	010	
#define SEE_ALL		04	/*has to be on for now*/
#define DOORS		02	/*not yet implemented*/
#define DIAGONAL_MOVE	01	/*not yet implemented*/

struct physics{
  unsigned char flags;
  }

struct layout{
  struct position timebox, play_by_play, messagebox, mapbox, statbox;
  };


typedef	 struct user  USER;
typedef	 struct game  GAME;
